# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section     free

%define parent plexus
%define subname tools
%define cdc_version 1.0.10
%define cli_version 1.4

Name:           plexus-tools
Version:        1.0.10
Release:        2%{?dist}
Epoch:          0
Summary:        Plexus Tools
License:        Apache Software License
Group:          Development/Java
URL:            http://plexus.codehaus.org/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.codehaus.org/plexus/plexus-tools/tags/plexus-tools-1.0.10/

Source1:        %{name}-jpp-depmap.xml
Patch0:         plexus-tools-cdc-DefaultComponentDescriptorWriterTest.patch
Patch1:         plexus-tools-cli-pom.patch
Patch2:         plexus-tools-pom.patch
Patch3:         plexus-tools-cdc-anno-pom.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-common-poms >= 0:1.0

BuildRequires:  jdom
BuildRequires:  jakarta-commons-cli
BuildRequires:  plexus-cdc
BuildRequires:  plexus-classworlds
BuildRequires:  plexus-component-annotations
BuildRequires:  plexus-container-default
BuildRequires:  plexus-utils
BuildRequires:  qdox
BuildRequires:  slf4j
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

Requires:       java >= 0:1.5.0
Requires:       jakarta-commons-cli
Requires:       jdom
Requires:       plexus-cdc
Requires:       plexus-classworlds
Requires:       plexus-component-annotations
Requires:       plexus-container-default
Requires:       plexus-utils
Requires:       qdox
Requires:       slf4j

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

%description
The Plexus project seeks to create end-to-end developer tools for
writing applications. At the core is the container, which can be
embedded or for a full scale application server. There are many
reusable components for hibernate, form processing, jndi, i18n,
velocity, etc. Plexus also includes an application server which
is like a J2EE application server, without all the baggage.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-jpp \
        -e \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/plexus
install -m 644 plexus-cdc-anno/target/*.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{parent}/tools-cdc-anno-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-cdc-anno 1.0-alpha-3 JPP/%{parent} tools-cdc-anno
install -m 644 plexus-cdc/target/*.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{parent}/tools-cdc-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-cdc 1.0-alpha-13 JPP/%{parent} tools-cdc
install -m 644 plexus-cli/target/*.jar \
          $RPM_BUILD_ROOT%{_javadir}/%{parent}/tools-cli-1.4.jar
%add_to_maven_depmap org.codehaus.plexus plexus-cli 1.4 JPP/%{parent} tools-cli

(cd $RPM_BUILD_ROOT%{_javadir}/%{parent} && for jar in *-%{cdc_version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{cdc_version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{parent} && for jar in *-%{cli_version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{cli_version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 plexus-cdc-anno/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-tools-cdc-anno.pom
install -m 644 plexus-cdc/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-tools-cdc.pom
install -m 644 plexus-cli/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-tools-cli.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools-cdc-anno
cp -pr plexus-cdc-anno/target/site/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools-cdc-anno/
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools-cdc
cp -pr plexus-cdc/target/site/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools-cdc/
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools-cli
cp -pr plexus-cli/target/site/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tools-cli/

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/plexus/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{subname}*-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}


%changelog
* Wed May 27 2009 Ralph Apel <r.apel at r-apel.de> 0:1.0.10-2.jpp5
- Fix versionless symlinks

* Mon Feb 09 2008 Ralph Apel <r.apel at r-apel.de> 0:1.0.10-1.jpp5
- 1.0.10

